function Est31700_Etiqueta_de_Produto_Controller(ScreenService, restEngine,  General, templateManager, ZhFilterPreferences){
    

    this.validacoesWidgetOnEnterOnce = function(filtroArgs) {
        var cabecalhoWidget = filtroArgs.owner;
        const defaultFilter = {
             "P_DTENTRSAID" : "01/01/2019",
             "P_IDENTRSAIDOP": "E",
             "FILTRADOPOR": "NF",
             "NRLANCTONF":"",
             "CDFILIAL":"",
             "NRORG": ""
        };
        General.callRestEngine("est#/crud/filial", "FilterData", [{name: "CDFILIAL", operator: "=", value: "FILIAL_LOGADA"}]).then((response) =>  {
            defaultFilter.CDFILIAL   = response.dataset.filial[0].CDFILIAL;
            defaultFilter.NMFILIAL   = response.dataset.filial[0].NMFILIAL;
            ZhFilterPreferences.setOriginalFilter(cabecalhoWidget.id, defaultFilter);
            ZhFilterPreferences.openFilterWidget(cabecalhoWidget, defaultFilter);
        },
        (error) => {
            ZhFilterPreferences.openFilterWidget(cabecalhoWidget);
        });
    };

    
  this.removeCaposFiltrer = function(args){
      
        args.e.preventDefault();
        
        let currentRow = args.e.preference.FILTER_ROW;
        var filters = [ 
            {
                name: "NRLANCTONF",
                operator: "=",
                value: currentRow.NRLANCTONF
            },
            
            {
                name: "CDFILIAL",
                operator: "=",
                value: currentRow.CDFILIAL
            }
        ];
        
        
        
        args.owner.dataSourceFilter = filters;
        args.owner.reload();
  };
    
    this.getFieldValueFilter = function(filedName, widgetName) {
        var container =  templateManager.container;
        if(container) {
            var filterWidget;
            var filterBforeApply = templateManager.container.getActiveWidget();
            if(filterBforeApply.name == 'zhFilterPreferencesSelectConditions')
              filterWidget = filterBforeApply;
            else {
                var f = container.getWidget(widgetName);
                if(f) {
                     filterWidget = container.getWidget(widgetName).appliedFilter;
                }
               
            }
            
            if(filterWidget) {
                var valueField;
                if(filterBforeApply.name == 'zhFilterPreferencesSelectConditions')
                    valueField = filterWidget.currentRow[filedName];
                else
                    valueField = filterWidget.FILTER_ROW[filedName];
                    
                return valueField || null;
            }
            else return null;
        }
        else return null;
    };
    
    /****************************************************************
     * Ao escolher as opções “Nº Nota Fiscal” ou “Nº Lançamento de NF” deverá ser 
     * apresentado na pesquisa de número os seguintes campos:
     * Número NF, Série, Data Entrada, Razão Social
     * Quando a pesquisa for por “Nº Lançamento de Estoque” deverá ser exibibido os campos:
     * Número, Data Lançamento
     * ***************************************************************/
    this.HabilitaCamposNumero = function(widget) {
        switch(widget.currentRow.FILTRADOPOR){
            case "NF":

                widget.getField("NUMERO").dataSource.name = "est_relatorios#/crud/numero";
                widget.getField("NUMERO").searchableFields = ["NUMERO", "SERIE"];
                widget.getField("NUMERO").displayedFields = ["NUMERO", "SERIE"];
                widget.getField("NUMERO").dataSourceFilter[2].name = "P_DTENTRSAID";
                
                if (widget.getField("NUMERO").selectWidget){
   
                    widget.getField("NUMERO").dataSource.name = "est_relatorios#/crud/numero";
                    widget.getField("NUMERO").selectWidget.getField("NUMERO").showOnList = true;
                    widget.getField("NUMERO").selectWidget.getField("SERIE").showOnList = true;
                    widget.getField("NUMERO").selectWidget.getField("DATA").showOnList = true;
                    widget.getField("NUMERO").selectWidget.getField("NMRAZSOCFORN").showOnList = true;
                    widget.getField("NUMERO").selectWidget.getField("IDENTRSAIDOP").showOnList = false;
                }else {
                    widget.getField("NUMERO").getField("NUMERO").showOnList = true;
                    widget.getField("NUMERO").getField("SERIE").showOnList = true;
                    widget.getField("NUMERO").getField("DATA").showOnList = true;
                    widget.getField("NUMERO").getField("NMRAZSOCFORN").showOnList = true;
                    widget.getField("NUMERO").getField("IDENTRSAIDOP").showOnList = false;
                }
            break;
            case "LNF":
                
                widget.getField("NUMERO").dataSource.name = "est_relatorios#/crud/numero";
                widget.getField("NUMERO").searchableFields = ["NRLANCTONF", "SERIE"];
                widget.getField("NUMERO").displayedFields = ["NRLANCTONF", "SERIE"];
                widget.getField("NUMERO").dataSourceFilter[2].name = "P_DTENTRSAID";
                

                if (widget.getField("NUMERO").selectWidget){
                    widget.getField("NUMERO").selectWidget.getField("NUMERO").showOnList = true;
                    widget.getField("NUMERO").selectWidget.getField("SERIE").showOnList = true;
                    widget.getField("NUMERO").selectWidget.getField("DATA").showOnList = true;
                    widget.getField("NUMERO").selectWidget.getField("NMRAZSOCFORN").showOnList = false;
                    widget.getField("NUMERO").selectWidget.getField("IDENTRSAIDOP").showOnList = false;
                }else {
                    widget.getField("NUMERO").getField("NUMERO").showOnList = true;
                    widget.getField("NUMERO").getField("SERIE").showOnList = true;
                    widget.getField("NUMERO").getField("DATA").showOnList = true;
                    widget.getField("NUMERO").getField("NMRAZSOCFORN").showOnList = false;
                    widget.getField("NUMERO").getField("IDENTRSAIDOP").showOnList = false;
                }
                
            break;
            case "LEst":
                
                widget.getField("NUMERO").dataSource.name = "est_relatorios#/crud/numeroLancamentoEstoque";
                widget.getField("NUMERO").searchableFields = ["NUMERO", "SERIE"];
                widget.getField("NUMERO").displayedFields =  ["NUMERO", "SERIE"];
                widget.getField("NUMERO").dataSourceFilter[2].name = "P_DTLANCESTQ";
                if (widget.getField("NUMERO").selectWidget){
                    widget.getField("NUMERO").selectWidget.getField("NUMERO").showOnList = true;
                    widget.getField("NUMERO").selectWidget.getField("SERIE").showOnList = true;
                    widget.getField("NUMERO").selectWidget.getField("DATA").showOnList = false;
                    widget.getField("NUMERO").selectWidget.getField("NMRAZSOCFORN").showOnList = false;
                    widget.getField("NUMERO").selectWidget.getField("IDENTRSAIDOP").showOnList = false;
                }else {
                    widget.getField("NUMERO").getField("NUMERO").showOnList = true;
                    widget.getField("NUMERO").getField("SERIE").showOnList = true;
                    widget.getField("NUMERO").getField("DATA").showOnList = false;
                    widget.getField("NUMERO").getField("NMRAZSOCFORN").showOnList = false;
                    widget.getField("NUMERO").getField("IDENTRSAIDOP").showOnList = false;

                }
            break;
            default: 
                 widget.getField("NUMERO").readOnly = true;  
        }
    };
    
    this.HabilitaNumero = function(widget){
        if((widget.currentRow.FILTRADOPOR == null || widget.currentRow.FILTRADOPOR == undefined || widget.currentRow.FILTRADOPOR == "") || (widget.currentRow.P_IDENTRSAIDOP == null || widget.currentRow.P_IDENTRSAIDOP == undefined || widget.currentRow.P_IDENTRSAIDOP == "") || (widget.currentRow.P_DTENTRSAID == null || widget.currentRow.P_DTENTRSAID == undefined || widget.currentRow.P_DTENTRSAID == "") || (widget.currentRow.NMFILIAL == null || widget.currentRow.NMFILIAL == undefined || widget.currentRow.NMFILIAL == "") ){
             widget.getField("NUMERO").readOnly = true; 
        }else {
             widget.getField("NUMERO").readOnly = false;
        }
        widget.currentRow.NUMERO = '';
        widget.getField("NUMERO").reload();
    };
    
    this.gerarEtiqueta = function (widget) {
       let rows = widget.getCheckedRows();
       let ignoresProperties = ["__is_new" , "__isSelected"];
       let produtos = [];
       
       rows.forEach( function(row){
           row.CDFILIAL =
           produtos.push(Util.clone(row, ignoresProperties));
       } );
       
       if(widget.hasCheckedRows()){
           this.requestReport(produtos).then(function(birtURL){
               window.open(birtURL.dataset.URL[0]);
           });
       }
    };
    
    this.requestReport = function(rows){
          return restEngine.post('est_relatorios#/etiqueta_De_Produto', {
            "requestType": "DataSet",
            "dataset": rows
        });
    };
    
    this.onChangeFilial = function(widget){
        var numero = widget.getField("NUMERO");
        
        numero.dataSourceFilter[1] = 
            {
                "name": "P_CDFILIAL",
                "operator": "=",
                "value": widget.currentRow.CDFILIAL
            };
    };
    
    this.onChangeData = function(widget){
        var numero = widget.getField("NUMERO");
        var data = widget.getField("P_DTENTRSAID");
        
        numero.dataSourceFilter[2] = 
            {
                "name": "P_DTENTRSAID",
                "operator": "=",
                "value": data.value()
            };
    };
    
    this.onChangeId = function(widget){
        var numero = widget.getField("NUMERO");
        var id = widget.getField("P_IDENTRSAIDOP");
        
        numero.dataSourceFilter[0] = 
            {
                "name": "P_IDENTRSAIDOP",
                "operator": "=",
                "value": id.value()
            };
    };
    
    this.initializeNumero = function(args){
        var widget = args.owner.field.widget;
        var numero = widget.getField("NUMERO");
        
        numero.dataSourceFilter = [
                {
                    "name": "P_IDENTRSAIDOP",
                    "operator": "=",
                    "value": widget.getField("P_IDENTRSAIDOP").value()
                },
                {
                    "name": "P_CDFILIAL",
                    "operator": "=",
                    "value": widget.currentRow.CDFILIAL
                },
                {
                    "name": "P_DTENTRSAID",
                    "operator": "=",
                    "value": widget.getField("P_DTENTRSAID").value()
                }
            ];
        numero.reload();
    };
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register('Est31700_Etiqueta_de_Produto_Controller', Est31700_Etiqueta_de_Produto_Controller);
});